﻿using DAL.Models;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DAL.Data
{
    public static class DataInitializer
    {
        //Specifying IDs is mandatory if seeding db through OnModelCreating method
        public static void Seed(this ModelBuilder modelBuilder)
        {
            var ferko = new Student { Id = 1, Name = "Ferko Mrkvicka" };
            var jozko = new Student { Id = 2, Name = "Jozko Mrkvicka" };
            var kontr = new Student { Id = 666, Name = "Legendary Kontr" };

            modelBuilder.Entity<Student>().HasData(ferko);
            modelBuilder.Entity<Student>().HasData(jozko);
            modelBuilder.Entity<Student>().HasData(kontr);

            var a315 = new Classroom { Name = "A315", Id = 1 };
            var a217 = new Classroom { Name = "A217", Id = 2 };

            modelBuilder.Entity<Classroom>().HasData(a315);
            modelBuilder.Entity<Classroom>().HasData(a217);

            var pv178 = new Subject { Id = 1, Name = "Programming in C#", ClassroomId = 2 };
            var pv179 = new Subject { Id = 2, Name = "App Development in C#", ClassroomId = 2 };
            var ib111 = new Subject { Id = 3, Name = "Python programming", ClassroomId = 1 };

            modelBuilder.Entity<Subject>().HasData(pv178);
            modelBuilder.Entity<Subject>().HasData(pv179);
            modelBuilder.Entity<Subject>().HasData(ib111);

        }
    }
}
